'use strict';

var _extends = require('babel-runtime/helpers/extends')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _Object$defineProperty = require('babel-runtime/core-js/object/define-property')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

_Object$defineProperty(exports, '__esModule', {
  value: true
});

exports['default'] = inject;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Injector = require('../Injector');

var _Injector2 = _interopRequireDefault(_Injector);

var _getDisplayName = require('./getDisplayName');

var _getDisplayName2 = _interopRequireDefault(_getDisplayName);

function mergePropsStateAndActions(_ref) {
  var props = _ref.props;
  var state = _ref.state;
  var actions = _ref.actions;

  return _extends({}, props, state, actions);
}

function inject(_ref2) {
  var actionsToInject = _ref2.actions;
  var storesToConnect = _ref2.stores;
  var getChildProps = arguments[1] === undefined ? mergePropsStateAndActions : arguments[1];

  return function (DecoratedComponent) {
    return (function () {
      function ReduxInjectorDecorator() {
        _classCallCheck(this, ReduxInjectorDecorator);

        this.renderChild = this.renderChild.bind(this);
      }

      _createClass(ReduxInjectorDecorator, [{
        key: 'render',
        value: function render() {
          return _react2['default'].createElement(
            _Injector2['default'],
            { actions: actionsToInject,
              stores: storesToConnect },
            this.renderChild
          );
        }
      }, {
        key: 'renderChild',
        value: function renderChild(_ref3) {
          var state = _ref3.state;
          var actions = _ref3.actions;
          var props = this.props;

          var childProps = getChildProps({ props: props, state: state, actions: actions });

          return _react2['default'].createElement(DecoratedComponent, childProps);
        }
      }], [{
        key: 'displayName',
        value: 'ReduxInjector(' + (0, _getDisplayName2['default'])(DecoratedComponent) + ')',
        enumerable: true
      }]);

      return ReduxInjectorDecorator;
    })();
  };
}

module.exports = exports['default'];